opencv: cv::OneWayDescriptorBase Class Reference

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes

# cv::OneWayDescriptorBase Class Reference

`#include <features2d.hpp>`

Inheritance diagram for cv::OneWayDescriptorBase:

List of all members.

## Public Member Functions
void | Allocate (int train_feature_count)
void | AllocatePCADescriptors ()
void | clear ()
void | ConvertDescriptorsArrayToTree ()
void | CreateDescriptorsFromImage (IplImage *src, const std::vector< cv::KeyPoint > &features)
void | CreatePCADescriptors ()
void | FindDescriptor (IplImage *src, cv::Point2f pt, int &desc_idx, int &pose_idx, float &distance) const
void | FindDescriptor (IplImage *patch, int &desc_idx, int &pose_idx, float &distance, float *_scale=0, float *scale_ranges=0) const
void | FindDescriptor (IplImage *patch, int n, std::vector< int > &desc_idxs, std::vector< int > &pose_idxs, std::vector< float > &distances, std::vector< float > &_scales, float *scale_ranges=0) const
void | GeneratePCA (const char *img_path, const char *images_list, int pose_count=500)
const OneWayDescriptor * | GetDescriptor (int desc_idx) const
int | GetDescriptorCount () const
int | GetLowPCA (CvMat **avg, CvMat **eigenvectors)
CvSize | GetPatchSize () const
int | GetPCADimHigh () const
int | GetPCADimLow () const
int | GetPoseCount () const
int | GetPyrLevels () const
void | InitializeDescriptor (int desc_idx, IplImage *train_image, const cv::KeyPoint &keypoint, const char *feature_label)
void | InitializeDescriptor (int desc_idx, IplImage *train_image, const char *feature_label)
void | InitializeDescriptors (IplImage *train_image, const vector< cv::KeyPoint > &features, const char *feature_label="", int desc_start_idx=0)
void | InitializePoses ()
void | InitializePoseTransforms ()
void | InitializeTransformsFromPoses ()
int | LoadPCADescriptors (const char *filename)
int | LoadPCADescriptors (const FileNode &fn)
| OneWayDescriptorBase (CvSize patch_size, int pose_count, const char *train_path=0, const char *pca_config=0, const char *pca_hr_config=0, const char *pca_desc_config=0, int pyr_levels=1, int pca_dim_high=100, int pca_dim_low=100)
| OneWayDescriptorBase (CvSize patch_size, int pose_count, const string &pca_filename, const string &train_path=string(), const string &images_list=string(), float _scale_min=0.7f, float _scale_max=1.5f, float _scale_step=1.2f, int pyr_levels=1, int pca_dim_high=100, int pca_dim_low=100)
void | Read (const FileNode &fn)
void | SavePCADescriptors (const char *filename)
void | SavePCADescriptors (CvFileStorage *fs) const
void | SetPCAHigh (CvMat *avg, CvMat *eigenvectors)
void | SetPCALow (CvMat *avg, CvMat *eigenvectors)
void | Write (FileStorage &fs) const
virtual | ~OneWayDescriptorBase ()
## Static Public Member Functions
static string | GetPCAFilename ()
## Protected Member Functions
void | LoadPCAall (const FileNode &fn)
void | SavePCAall (FileStorage &fs) const
## Protected Attributes
OneWayDescriptor * | m_descriptors
CvSize | m_patch_size
CvMat * | m_pca_avg
OneWayDescriptor * | m_pca_descriptors
CvMat * | m_pca_descriptors_matrix
cv::flann::Index * | m_pca_descriptors_tree
int | m_pca_dim_high
int | m_pca_dim_low
CvMat * | m_pca_eigenvectors
CvMat * | m_pca_hr_avg
CvMat * | m_pca_hr_eigenvectors
int | m_pose_count
CvAffinePose * | m_poses
int | m_pyr_levels
int | m_train_feature_count
CvMat ** | m_transforms
float | scale_max
float | scale_min
float | scale_step

## Constructor & Destructor Documentation

cv::OneWayDescriptorBase::OneWayDescriptorBase | ( | CvSize | patch_size,
|  | int | pose_count,
|  | const char * | train_path = `0`,
|  | const char * | pca_config = `0`,
|  | const char * | pca_hr_config = `0`,
|  | const char * | pca_desc_config = `0`,
|  | int | pyr_levels = `1`,
|  | int | pca_dim_high = `100`,
|  | int | pca_dim_low = `100`
| ) |  |

cv::OneWayDescriptorBase::OneWayDescriptorBase | ( | CvSize | patch_size,
|  | int | pose_count,
|  | const string & | pca_filename,
|  | const string & | train_path = `string()`,
|  | const string & | images_list = `string()`,
|  | float | _scale_min = `0.7f`,
|  | float | _scale_max = `1.5f`,
|  | float | _scale_step = `1.2f`,
|  | int | pyr_levels = `1`,
|  | int | pca_dim_high = `100`,
|  | int | pca_dim_low = `100`
| ) |  |

virtual cv::OneWayDescriptorBase::~OneWayDescriptorBase | ( | ) | `[virtual]`

## Member Function Documentation

void cv::OneWayDescriptorBase::Allocate | ( | int | train_feature_count ) |

void cv::OneWayDescriptorBase::AllocatePCADescriptors | ( | ) |

void cv::OneWayDescriptorBase::clear | ( | ) |

void cv::OneWayDescriptorBase::ConvertDescriptorsArrayToTree | ( | ) |

void cv::OneWayDescriptorBase::CreateDescriptorsFromImage | ( | IplImage * | src,
|  | const std::vector< cv::KeyPoint > & | features
| ) |  |

void cv::OneWayDescriptorBase::CreatePCADescriptors | ( | ) |

void cv::OneWayDescriptorBase::FindDescriptor | ( | IplImage * | patch,
|  | int & | desc_idx,
|  | int & | pose_idx,
|  | float & | distance,
|  | float * | _scale = `0`,
|  | float * | scale_ranges = `0`
| ) |  | const

void cv::OneWayDescriptorBase::FindDescriptor | ( | IplImage * | patch,
|  | int | n,
|  | std::vector< int > & | desc_idxs,
|  | std::vector< int > & | pose_idxs,
|  | std::vector< float > & | distances,
|  | std::vector< float > & | _scales,
|  | float * | scale_ranges = `0`
| ) |  | const

void cv::OneWayDescriptorBase::FindDescriptor | ( | IplImage * | src,
|  | cv::Point2f | pt,
|  | int & | desc_idx,
|  | int & | pose_idx,
|  | float & | distance
| ) |  | const

void cv::OneWayDescriptorBase::GeneratePCA | ( | const char * | img_path,
|  | const char * | images_list,
|  | int | pose_count = `500`
| ) |  |

const OneWayDescriptor* cv::OneWayDescriptorBase::GetDescriptor | ( | int | desc_idx ) | const`[inline]`

int cv::OneWayDescriptorBase::GetDescriptorCount | ( | ) | const`[inline]`

int cv::OneWayDescriptorBase::GetLowPCA | ( | CvMat ** | avg,
|  | CvMat ** | eigenvectors
| ) |  | `[inline]`

CvSize cv::OneWayDescriptorBase::GetPatchSize | ( | ) | const`[inline]`

int cv::OneWayDescriptorBase::GetPCADimHigh | ( | ) | const`[inline]`

int cv::OneWayDescriptorBase::GetPCADimLow | ( | ) | const`[inline]`

static string cv::OneWayDescriptorBase::GetPCAFilename | ( | ) | `[inline, static]`

int cv::OneWayDescriptorBase::GetPoseCount | ( | ) | const`[inline]`

int cv::OneWayDescriptorBase::GetPyrLevels | ( | ) | const`[inline]`

void cv::OneWayDescriptorBase::InitializeDescriptor | ( | int | desc_idx,
|  | IplImage * | train_image,
|  | const char * | feature_label
| ) |  |

void cv::OneWayDescriptorBase::InitializeDescriptor | ( | int | desc_idx,
|  | IplImage * | train_image,
|  | const cv::KeyPoint & | keypoint,
|  | const char * | feature_label
| ) |  |

void cv::OneWayDescriptorBase::InitializeDescriptors | ( | IplImage * | train_image,
|  | const vector< cv::KeyPoint > & | features,
|  | const char * | feature_label = `""`,
|  | int | desc_start_idx = `0`
| ) |  |

void cv::OneWayDescriptorBase::InitializePoses | ( | ) |

void cv::OneWayDescriptorBase::InitializePoseTransforms | ( | ) |

void cv::OneWayDescriptorBase::InitializeTransformsFromPoses | ( | ) |

void cv::OneWayDescriptorBase::LoadPCAall | ( | const FileNode & | fn ) | `[protected]`

int cv::OneWayDescriptorBase::LoadPCADescriptors | ( | const FileNode & | fn ) |

int cv::OneWayDescriptorBase::LoadPCADescriptors | ( | const char * | filename ) |

void cv::OneWayDescriptorBase::Read | ( | const FileNode & | fn ) |

void cv::OneWayDescriptorBase::SavePCAall | ( | FileStorage & | fs ) | const`[protected]`

void cv::OneWayDescriptorBase::SavePCADescriptors | ( | const char * | filename ) |

void cv::OneWayDescriptorBase::SavePCADescriptors | ( | CvFileStorage * | fs ) | const

void cv::OneWayDescriptorBase::SetPCAHigh | ( | CvMat * | avg,
|  | CvMat * | eigenvectors
| ) |  |

void cv::OneWayDescriptorBase::SetPCALow | ( | CvMat * | avg,
|  | CvMat * | eigenvectors
| ) |  |

void cv::OneWayDescriptorBase::Write | ( | FileStorage & | fs ) | const

## Member Data Documentation

OneWayDescriptor* cv::OneWayDescriptorBase::m_descriptors`[protected]`

CvSize cv::OneWayDescriptorBase::m_patch_size`[protected]`

CvMat* cv::OneWayDescriptorBase::m_pca_avg`[protected]`

OneWayDescriptor* cv::OneWayDescriptorBase::m_pca_descriptors`[protected]`

CvMat* cv::OneWayDescriptorBase::m_pca_descriptors_matrix`[protected]`

cv::flann::Index* cv::OneWayDescriptorBase::m_pca_descriptors_tree`[protected]`

int cv::OneWayDescriptorBase::m_pca_dim_high`[protected]`

int cv::OneWayDescriptorBase::m_pca_dim_low`[protected]`

CvMat* cv::OneWayDescriptorBase::m_pca_eigenvectors`[protected]`

CvMat* cv::OneWayDescriptorBase::m_pca_hr_avg`[protected]`

CvMat* cv::OneWayDescriptorBase::m_pca_hr_eigenvectors`[protected]`

int cv::OneWayDescriptorBase::m_pose_count`[protected]`

CvAffinePose* cv::OneWayDescriptorBase::m_poses`[protected]`

int cv::OneWayDescriptorBase::m_pyr_levels`[protected]`

int cv::OneWayDescriptorBase::m_train_feature_count`[protected]`

CvMat** cv::OneWayDescriptorBase::m_transforms`[protected]`

float cv::OneWayDescriptorBase::scale_max`[protected]`

float cv::OneWayDescriptorBase::scale_min`[protected]`

float cv::OneWayDescriptorBase::scale_step`[protected]`

The documentation for this class was generated from the following file:

- /usr/ports/pobj/OpenCV-2.2.0/OpenCV-2.2.0/modules/features2d/include/opencv2/features2d/features2d.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines